from z3 import *
from random import randint
import random
import time
import statistics

nNativelySupported = Real('nNativelySupported')
newNodesCreated = Int('newNodesCreated')
nNewSupported = Real('nNewSupported')


nServices = 9
nNodes = 15

nativelySupported = [ Bool("nativelySService_%s" % (c)) for c in range(nServices) ]
newNodesRequired = [ Bool("newNode_%s" % (c)) for c in range(nServices) ]
newSupported = [ Bool("newSService_%s" % (c)) for c in range(nServices) ]


services = [ [ 0 for c in range(9) ] 
      for r in range(nServices) ]

#{0-CPU, 1-RAM, 2-transmissionUp, 3-transmissionDown, 4-sensingRequirements, 5-peripheral requirements, 6-F/A associated(clonables), 7-typeDevice, 8-location}
#Transmit contains a negative value if none of the childs of the clonable service have CMCs. If yes, contains the dictionary with the values cross values.
services[0][0] = 0 #Parking
services[0][1] = 0
services[0][2] = 0
services[0][3] = 0
services[0][4] = {'parking'}
services[0][5] = {''}
services[0][6] = {}
services[0][7] = 'sensing'
services[0][8] = 'P1'

services[1][0] = 0 #Parking
services[1][1] = 0
services[1][2] = 0
services[1][3] = 0
services[1][4] = {'parking'}
services[1][5] = {''}
services[1][6] = {}
services[1][7] = 'sensing'
services[1][8] = 'P2'


services[2][0] = 0 #Classroom
services[2][1] = 100
services[2][2] = 1800*1024
services[2][3] = 0
services[2][4] = {''}
services[2][5] = {'camera', 'microphone'}
services[2][6] = {0}
services[2][7] = 'computing'
services[2][8] = 'C4'


services[3][0] = 0 #Classroom
services[3][1] = 100
services[3][2] = 1000*1024
services[3][3] = 0
services[3][4] = {''}
services[3][5] = {'camera', 'microphone'}
services[3][6] = {0}
services[3][7] = 'computing'
services[3][8] = 'C9'


services[4][0] = 0 #Classroom
services[4][1] = 100
services[4][2] = 3600*1024
services[4][3] = 0
services[4][4] = {''}
services[4][5] = {'camera', 'microphone'}
services[4][6] = {0}
services[4][7] = 'computing'
services[4][8] = 'C1'

services[5][0] = 0 #Classroom
services[5][1] = 0
services[5][2] = 0
services[5][3] = 0
services[5][4] = {''}
services[5][5] = {''}
services[5][6] = {0}
services[5][7] = 'smartLock'
services[5][8] = 'C1'


services[6][0] = 0 #Environmental
services[6][1] = 0
services[6][2] = 0
services[6][3] = 0
services[6][4] = {'temperature', 'humidity', 'wind'}
services[6][5] = {''}
services[6][6] = {}
services[6][7] = 'sensing'
services[6][8] = 'M2'


services[7][0] = 0 #Office
services[7][1] = 0
services[7][2] = 0
services[7][3] = 0
services[7][4] = {'presence'}
services[7][5] = {''}
services[7][6] = {}
services[7][7] = 'sensing'
services[7][8] = 'O5'

services[8][0] = 0 #Office
services[8][1] = 0
services[8][2] = 0
services[8][3] = 0
services[8][4] = {'presence'}
services[8][5] = {''}
services[8][6] = {}
services[8][7] = 'sensing'
services[8][8] = 'O2'   #'none' if doesnt care


#Clonable and name
servicesName = {'0': 'Smart parking', '1': 'Telematic Classroom', '2': 'Environmental information', '3' : 'Smart office'}


#MATCHING THE FEATURES CONTAINED IN CLONABLE WITH THE ONES CONTAINED IN THE LIST FEATURES (WHICH CONTAINS ALL THE FEATURES)
#key -> clonable id, value -> serviceId
serviceMatch = {'0': 0, '1' : 1, '2' : 2, '3': 3, '4': 4, '5' : 5, '6' : 6, '7': 7, '8': 8, '9' : 9, '10' : 10, '11': 11, '12' : 12}
	
#{CPU, Bandwidth. Power Upload, k, RAM, policy, Power Download, BandwidthDown,sensing units, peripherals, type, location, owner}

nodes = [ [ 0 for c in range(14) ] 
	for r in range(nNodes) ]

#{0- CPU, 1-BandwidthUp. 2-Power Upload, 3-k, 4-RAM, 5-policy, 6-Power Download, 7-BandwidthDown, 8-peripheralps {}, 9-sensing units {}, 10-type,11-id, 12-owner}
#DEVICES
nodes[0][0] = random.uniform(1000000000,2200000000)
nodes[0][1] = random.uniform(1700000,4686400)
nodes[0][2] = random.uniform(0.04,0.05)
nodes[0][3] = random.uniform(0.00001,0.00002)
nodes[0][4] = random.uniform(1000,4000)
nodes[0][5] = 1
nodes[0][6] = random.uniform(0.04,0.05)
nodes[0][7] = random.uniform(1700000,1900000)
nodes[0][8] = {'camera', 'microphone'}
nodes[0][9] = {''}
nodes[0][10] = 'computing'
nodes[0][11] = 'C4'
nodes[0][12] = 'public'
nodes[0][13] = {'wlan','BLE'}

nodes[1][0] = random.uniform(1000000000,2200000000)
nodes[1][1] = random.uniform(1700000,4686400)
nodes[1][2] = random.uniform(0.04,0.05)
nodes[1][3] = random.uniform(0.00001,0.00002)
nodes[1][4] = random.uniform(1000,4000)
nodes[1][5] = 1
nodes[1][6] = random.uniform(0.04,0.05)
nodes[1][7] = random.uniform(1700000,1900000)
nodes[1][8] = {'camera', 'microphone'}
nodes[1][9] = {''}
nodes[1][10] = 'computing'
nodes[1][11] = 'C6'
nodes[1][12] = 'public'
nodes[1][13] = {'wlan','BLE'}

nodes[2][0] = random.uniform(1000000000,2200000000)
nodes[2][1] = random.uniform(1700000,4686400)
nodes[2][2] = random.uniform(0.04,0.05)
nodes[2][3] = random.uniform(0.00001,0.00002)
nodes[2][4] = random.uniform(1000,4000)
nodes[2][5] = 1
nodes[2][6] = random.uniform(0.04,0.05)
nodes[2][7] = random.uniform(1700000,1900000)
nodes[2][8] = {'camera', 'microphone'}
nodes[2][9] = {''}
nodes[2][10] = 'computing'
nodes[2][11] = 'C9'
nodes[2][12] = 'public'
nodes[2][13] = {'wlan','BLE'}

nodes[3][0] = random.uniform(1000000000,2200000000)
nodes[3][1] = random.uniform(1700000,4686400)
nodes[3][2] = random.uniform(0.04,0.05)
nodes[3][3] = random.uniform(0.00001,0.00002)
nodes[3][4] = random.uniform(1000,4000)
nodes[3][5] = 1
nodes[3][6] = random.uniform(0.04,0.05)
nodes[3][7] = random.uniform(1700000,1900000)
nodes[3][8] = {'camera', 'microphone'}
nodes[3][9] = {''}
nodes[3][10] = 'computing'
nodes[3][11] = 'C10'
nodes[3][12] = 'public'
nodes[3][13] = {'wlan','BLE'}

#PARKING SENSORS
nodes[4][0] = 10
nodes[4][1] = 10
nodes[4][2] = 0.05
nodes[4][3] = 0.0001
nodes[4][4] = 10
nodes[4][5] = 1
nodes[4][6] = 0.05
nodes[4][7] = 10
nodes[4][8] = {''}
nodes[4][9] = {'parking'}
nodes[4][10] = 'sensing'
nodes[4][11] = 'P7'
nodes[4][12] = 'public'
nodes[4][13] = {'BLE'}

nodes[5][0] = 0
nodes[5][1] = 0
nodes[5][2] = 0.05
nodes[5][3] = 0.0001
nodes[5][4] = 10
nodes[5][5] = 1
nodes[5][6] = 0.05
nodes[5][7] = 10
nodes[5][8] = {''}
nodes[5][9] = {'parking'}
nodes[5][10] = 'sensing'
nodes[5][11] = 'P1'
nodes[5][12] = 'public'
nodes[5][13] = {'BLE'}

nodes[6][0] = 0
nodes[6][1] = 0
nodes[6][2] = 0.05
nodes[6][3] = 0.0001
nodes[6][4] = 10
nodes[6][5] = 1
nodes[6][6] = 0.05
nodes[6][7] = 10
nodes[6][8] = {''}
nodes[6][9] = {'parking'}
nodes[6][10] = 'sensing'
nodes[6][11] = 'P2'
nodes[6][12] = 'public'
nodes[6][13] = {'BLE'}


nodes[7][0] = 10
nodes[7][1] = 10
nodes[7][2] = 0.05
nodes[7][3] = 0.0001
nodes[7][4] = 10
nodes[7][5] = 1
nodes[7][6] = 0.05
nodes[7][7] = 10
nodes[7][8] = {''}
nodes[7][9] = {'parking'}
nodes[7][10] = 'sensing'
nodes[7][11] = 'P4'
nodes[7][12] = 'public'
nodes[7][13] = {'BLE'}

nodes[8][0] = 10
nodes[8][1] = 10
nodes[8][2] = 0.05
nodes[8][3] = 0.0001
nodes[8][4] = 10
nodes[8][5] = 1
nodes[8][6] = 0.05
nodes[8][7] = 10
nodes[8][8] = {''}
nodes[8][9] = {'presence'}
nodes[8][10] = 'sensing'
nodes[8][11] = 'O2'
nodes[8][12] = 'public'
nodes[8][13] = {'BLE'}

nodes[9][0] = 10
nodes[9][1] = 10
nodes[9][2] = 0.05
nodes[9][3] = 0.0001
nodes[9][4] = 10
nodes[9][5] = 1
nodes[9][6] = 0.05
nodes[9][7] = 10
nodes[9][8] = {''}
nodes[9][9] = {'presence'}
nodes[9][10] = 'sensing'
nodes[9][11] = 'O5'
nodes[9][12] = 'public'
nodes[9][13] = {'BLE'}


nodes[10][0] = 10
nodes[10][1] = 10
nodes[10][2] = 0.05
nodes[10][3] = 0.0001
nodes[10][4] = 10
nodes[10][5] = 1
nodes[10][6] = 0.05
nodes[10][7] = 10
nodes[10][8] = {''}
nodes[10][9] = {'presence'}
nodes[10][10] = 'sensing'
nodes[10][11] = 'O7'
nodes[10][12] = 'public'
nodes[10][13] = {'BLE'}

nodes[11][0] = 0
nodes[11][1] = 0
nodes[11][2] = 0.05
nodes[11][3] = 0.0001
nodes[11][4] = 4000.0
nodes[11][5] = 1
nodes[11][6] = 0.05
nodes[11][7] = 10
nodes[11][8] = {''}
nodes[11][9] = {'presence'}
nodes[11][10] = 'sensing'
nodes[11][11] = 'O9'
nodes[11][12] = 'public'
nodes[11][13] = {'BLE'}


nodes[12][0] = 10
nodes[12][1] = 10
nodes[12][2] = 0.05
nodes[12][3] = 0.0001
nodes[12][4] = 10
nodes[12][5] = 1
nodes[12][6] = 0.05
nodes[12][7] = 10
nodes[12][8] = {''}
nodes[12][9] = {'temperature', 'humidity', 'wind'}
nodes[12][10] = 'sensing'
nodes[12][11] = 'M2'
nodes[12][12] = 'public'
nodes[12][13] = {'BLE'}


nodes[13][0] = random.uniform(1000000000,1200000000)
nodes[13][1] = random.uniform(1700000,1900000)
nodes[13][2] = random.uniform(0.04,0.05)
nodes[13][3] = random.uniform(0.00001,0.00002)
nodes[13][4] = random.uniform(1000,4000)
nodes[13][5] = 1
nodes[13][6] = random.uniform(0.04,0.05)
nodes[13][7] = random.uniform(1700000,1900000)
nodes[13][8] = {''}
nodes[13][9] = {''}
nodes[13][10] = 'computing'
nodes[13][11] = 'edge'
nodes[13][12] = 'public'
nodes[13][13] = {'wlan','BLE'}

nodes[14][0] = random.uniform(1000000000,1200000000)
nodes[14][1] = random.uniform(1700000,1900000)
nodes[14][2] = random.uniform(0.04,0.05)
nodes[14][3] = random.uniform(0.00001,0.00002)
nodes[14][4] = random.uniform(1000,4000)
nodes[14][5] = 1
nodes[14][6] = random.uniform(0.04,0.05)
nodes[14][7] = random.uniform(1700000,1900000)
nodes[14][8] = {''}
nodes[14][9] = {''}
nodes[14][10] = 'computing'
nodes[14][11] = 'edge'
nodes[14][12] = 'public'
nodes[14][13] = {'wlan','BLE'}


newNodes = []


def createNode(service):
	newNodes.append([ 0 for c in range(14)])
	aux = (len(newNodes)-1)
	newNodes[aux][0] = services[service][0]
	newNodes[aux][4] = services[service][1]
	newNodes[aux][1] = services[service][2]
	newNodes[aux][7] = services[service][3]
	newNodes[aux][9] = services[service][4]
	newNodes[aux][8] = services[service][5]
	newNodes[aux][11] = services[service][8]
	newNodes[aux][10] = services[service][7]

def mergeNodes():
	for i in range(len(newNodes)):
		withoutLocation = False
		ilocation = newNodes[i][11]
		if ilocation == 'none':
			withoutLocation = True
		for j in range(len(newNodes)):		
			if i!= j and (withoutLocation or (newNodes[i][11] == newNodes[j][11])) and (newNodes[i][10] == newNodes[j][10]):
				if newNodes[i][11] == newNodes[j][11]:
					newNodes[i][9] |=  newNodes[i][9]
					newNodes[i][8] |=  newNodes[i][8]
					newNodes[i][4] =  newNodes[i][4] + newNodes[j][4]
					if newNodes[i][0] < newNodes[j][0]:
						newNodes[i][0] = newNodes[j][0]
					if newNodes[i][1] < newNodes[j][1]:
						newNodes[i][1] = newNodes[j][1]
					newNodes[j][11] = 'discarded'


opt = Optimize()

for i in range(nServices):
	opt.add(If(nativelySupported[i], Sum([ If((services[i][3] <= nodes[n][7]) and (services[i][0] <= nodes[n][0]) and (services[i][1] <= nodes[n][4]) and (services[i][4] <= nodes[n][9]) and (services[i][2] <= nodes[n][1]) and (services[i][5] <= nodes[n][8]) and (services[i][7] == nodes[n][10]) and ((services[i][8] == nodes[n][11]) or (services[i][8]=='none')) ,1,0) for n in range(nNodes)]) >= 1,If(nativelySupported[i],False,True)))

opt.add(nNativelySupported == Sum([simplify(If(nativelySupported[i], 1, 0)) for i in range(nServices)]))

opt.maximize(nNativelySupported)

sat = opt.check()

m = opt.model()

print(opt.check())

m = opt.model()

print(m)

for n in range(nServices):
	if str(m[nativelySupported[n]]) == 'False':
		createNode(n)

mergeNodes()

print('\n *** New nodes to acquire: ***\n')
for n in range(len(newNodes)):
	if newNodes[n][11] != 'discarded':
		print(str(newNodes[n]) + '\n')